/* $Id: tf_open.c,v 1.3 2006/01/05 04:25:10 msteveb Exp $ */

/*

  Copyright (c) 2005 Steve Bennett <msteveb at ozemail.com.au>

  This file is part of libtopfield.

  libtopfield is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  puppy is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with puppy; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "usb_io.h"
#include "tf_open.h"
#include "usbutil.h"

#define TOPFIELD_VENDOR_ID 0x11DB
#define TOPFIELD_5000PVRT_ID 0x1000

int topfield_open(tf_handle *tf, int index)
{
	memset(tf, 0, sizeof(*tf));

	tf->dev = open_usb_dev(TOPFIELD_VENDOR_ID, TOPFIELD_5000PVRT_ID, index);

    if (!tf->dev) {
        return -1;
    }

	tf->timeout = TF_DEFAULT_TIMEOUT;
	tf->tracefh = stderr;

	/* Allocate a buffer big enough for a send/reply packet */
	tf->buf = malloc(0x10000);

	return 0;
}

void topfield_close(tf_handle *tf)
{
	if (tf->dev) {
		close_usb_dev(tf->dev);
		tf->dev = 0;
		free(tf->buf);
		tf->buf = 0;
	}
}
